/**
            GNU GENERAL PUBLIC LICENSE
               Version 2, June 1991

 Copyright (C) 1989, 1991 Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 Everyone is permitted to copy and distribute verbatim copies
 of this license document, but changing it is not allowed.

                Preamble

  The licenses for most software are designed to take away your
freedom to share and change it.  By contrast, the GNU General Public
License is intended to guarantee your freedom to share and change free
software--to make sure the software is free for all its users.  This
General Public License applies to most of the Free Software
Foundation's software and to any other program whose authors commit to
using it.  (Some other Free Software Foundation software is covered by
the GNU Lesser General Public License instead.)  You can apply it to
your programs, too.

  When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it
if you want it, that you can change the software or use pieces of it
in new free programs; and that you know you can do these things.

  To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.

  For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

  We protect your rights with two steps: (1) copyright the software, and
(2) offer you this license which gives you legal permission to copy,
distribute and/or modify the software.

  Also, for each author's protection and ours, we want to make certain
that everyone understands that there is no warranty for this free
software.  If the software is modified by someone else and passed on, we
want its recipients to know that what they have is not the original, so
that any problems introduced by others will not reflect on the original
authors' reputations.

  Finally, any free program is threatened constantly by software
patents.  We wish to avoid the danger that redistributors of a free
program will individually obtain patent licenses, in effect making the
program proprietary.  To prevent this, we have made it clear that any
patent must be licensed for everyone's free use or not licensed at all.

  The precise terms and conditions for copying, distribution and
modification follow.

            GNU GENERAL PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. This License applies to any program or other work which contains
a notice placed by the copyright holder saying it may be distributed
under the terms of this General Public License.  The "Program", below,
refers to any such program or work, and a "work based on the Program"
means either the Program or any derivative work under copyright law:
that is to say, a work containing the Program or a portion of it,
either verbatim or with modifications and/or translated into another
language.  (Hereinafter, translation is included without limitation in
the term "modification".)  Each licensee is addressed as "you".

Activities other than copying, distribution and modification are not
covered by this License; they are outside its scope.  The act of
running the Program is not restricted, and the output from the Program
is covered only if its contents constitute a work based on the
Program (independent of having been made by running the Program).
Whether that is true depends on what the Program does.

  1. You may copy and distribute verbatim copies of the Program's
source code as you receive it, in any medium, provided that you
conspicuously and appropriately publish on each copy an appropriate
copyright notice and disclaimer of warranty; keep intact all the
notices that refer to this License and to the absence of any warranty;
and give any other recipients of the Program a copy of this License
along with the Program.

You may charge a fee for the physical act of transferring a copy, and
you may at your option offer warranty protection in exchange for a fee.

  2. You may modify your copy or copies of the Program or any portion
of it, thus forming a work based on the Program, and copy and
distribute such modifications or work under the terms of Section 1
above, provided that you also meet all of these conditions:

    a) You must cause the modified files to carry prominent notices
    stating that you changed the files and the date of any change.

    b) You must cause any work that you distribute or publish, that in
    whole or in part contains or is derived from the Program or any
    part thereof, to be licensed as a whole at no charge to all third
    parties under the terms of this License.

    c) If the modified program normally reads commands interactively
    when run, you must cause it, when started running for such
    interactive use in the most ordinary way, to print or display an
    announcement including an appropriate copyright notice and a
    notice that there is no warranty (or else, saying that you provide
    a warranty) and that users may redistribute the program under
    these conditions, and telling the user how to view a copy of this
    License.  (Exception: if the Program itself is interactive but
    does not normally print such an announcement, your work based on
    the Program is not required to print an announcement.)

These requirements apply to the modified work as a whole.  If
identifiable sections of that work are not derived from the Program,
and can be reasonably considered independent and separate works in
themselves, then this License, and its terms, do not apply to those
sections when you distribute them as separate works.  But when you
distribute the same sections as part of a whole which is a work based
on the Program, the distribution of the whole must be on the terms of
this License, whose permissions for other licensees extend to the
entire whole, and thus to each and every part regardless of who wrote it.

Thus, it is not the intent of this section to claim rights or contest
your rights to work written entirely by you; rather, the intent is to
exercise the right to control the distribution of derivative or
collective works based on the Program.

In addition, mere aggregation of another work not based on the Program
with the Program (or with a work based on the Program) on a volume of
a storage or distribution medium does not bring the other work under
the scope of this License.

  3. You may copy and distribute the Program (or a work based on it,
under Section 2) in object code or executable form under the terms of
Sections 1 and 2 above provided that you also do one of the following:

    a) Accompany it with the complete corresponding machine-readable
    source code, which must be distributed under the terms of Sections
    1 and 2 above on a medium customarily used for software interchange; or,

    b) Accompany it with a written offer, valid for at least three
    years, to give any third party, for a charge no more than your
    cost of physically performing source distribution, a complete
    machine-readable copy of the corresponding source code, to be
    distributed under the terms of Sections 1 and 2 above on a medium
    customarily used for software interchange; or,

    c) Accompany it with the information you received as to the offer
    to distribute corresponding source code.  (This alternative is
    allowed only for noncommercial distribution and only if you
    received the program in object code or executable form with such
    an offer, in accord with Subsection b above.)

The source code for a work means the preferred form of the work for
making modifications to it.  For an executable work, complete source
code means all the source code for all modules it contains, plus any
associated interface definition files, plus the scripts used to
control compilation and installation of the executable.  However, as a
special exception, the source code distributed need not include
anything that is normally distributed (in either source or binary
form) with the major components (compiler, kernel, and so on) of the
operating system on which the executable runs, unless that component
itself accompanies the executable.

If distribution of executable or object code is made by offering
access to copy from a designated place, then offering equivalent
access to copy the source code from the same place counts as
distribution of the source code, even though third parties are not
compelled to copy the source along with the object code.

  4. You may not copy, modify, sublicense, or distribute the Program
except as expressly provided under this License.  Any attempt
otherwise to copy, modify, sublicense or distribute the Program is
void, and will automatically terminate your rights under this License.
However, parties who have received copies, or rights, from you under
this License will not have their licenses terminated so long as such
parties remain in full compliance.

  5. You are not required to accept this License, since you have not
signed it.  However, nothing else grants you permission to modify or
distribute the Program or its derivative works.  These actions are
prohibited by law if you do not accept this License.  Therefore, by
modifying or distributing the Program (or any work based on the
Program), you indicate your acceptance of this License to do so, and
all its terms and conditions for copying, distributing or modifying
the Program or works based on it.

  6. Each time you redistribute the Program (or any work based on the
Program), the recipient automatically receives a license from the
original licensor to copy, distribute or modify the Program subject to
these terms and conditions.  You may not impose any further
restrictions on the recipients' exercise of the rights granted herein.
You are not responsible for enforcing compliance by third parties to
this License.

  7. If, as a consequence of a court judgment or allegation of patent
infringement or for any other reason (not limited to patent issues),
conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License.  If you cannot
distribute so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you
may not distribute the Program at all.  For example, if a patent
license would not permit royalty-free redistribution of the Program by
all those who receive copies directly or indirectly through you, then
the only way you could satisfy both it and this License would be to
refrain entirely from distribution of the Program.

If any portion of this section is held invalid or unenforceable under
any particular circumstance, the balance of the section is intended to
apply and the section as a whole is intended to apply in other
circumstances.

It is not the purpose of this section to induce you to infringe any
patents or other property right claims or to contest validity of any
such claims; this section has the sole purpose of protecting the
integrity of the free software distribution system, which is
implemented by public license practices.  Many people have made
generous contributions to the wide range of software distributed
through that system in reliance on consistent application of that
system; it is up to the author/donor to decide if he or she is willing
to distribute software through any other system and a licensee cannot
impose that choice.

This section is intended to make thoroughly clear what is believed to
be a consequence of the rest of this License.

  8. If the distribution and/or use of the Program is restricted in
certain countries either by patents or by copyrighted interfaces, the
original copyright holder who places the Program under this License
may add an explicit geographical distribution limitation excluding
those countries, so that distribution is permitted only in or among
countries not thus excluded.  In such case, this License incorporates
the limitation as if written in the body of this License.

  9. The Free Software Foundation may publish revised and/or new versions
of the General Public License from time to time.  Such new versions will
be similar in spirit to the present version, but may differ in detail to
address new problems or concerns.

Each version is given a distinguishing version number.  If the Program
specifies a version number of this License which applies to it and "any
later version", you have the option of following the terms and conditions
either of that version or of any later version published by the Free
Software Foundation.  If the Program does not specify a version number of
this License, you may choose any version ever published by the Free Software
Foundation.

  10. If you wish to incorporate parts of the Program into other free
programs whose distribution conditions are different, write to the author
to ask for permission.  For software which is copyrighted by the Free
Software Foundation, write to the Free Software Foundation; we sometimes
make exceptions for this.  Our decision will be guided by the two goals
of preserving the free status of all derivatives of our free software and
of promoting the sharing and reuse of software generally.

                NO WARRANTY

  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
REPAIR OR CORRECTION.

  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.

             END OF TERMS AND CONDITIONS

        How to Apply These Terms to Your New Programs

  If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these terms.

  To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
convey the exclusion of warranty; and each file should have at least
the "copyright" line and a pointer to where the full notice is found.

    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Also add information on how to contact you by electronic and paper mail.

If the program is interactive, make it output a short notice like this
when it starts in an interactive mode:

    Gnomovision version 69, Copyright (C) year name of author
    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
    This is free software, and you are welcome to redistribute it
    under certain conditions; type `show c' for details.

The hypothetical commands `show w' and `show c' should show the appropriate
parts of the General Public License.  Of course, the commands you use may
be called something other than `show w' and `show c'; they could even be
mouse-clicks or menu items--whatever suits your program.

You should also get your employer (if you work as a programmer) or your
school, if any, to sign a "copyright disclaimer" for the program, if
necessary.  Here is a sample; alter the names:

  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
  `Gnomovision' (which makes passes at compilers) written by James Hacker.

  <signature of Ty Coon>, 1 April 1989
  Ty Coon, President of Vice

This General Public License does not permit incorporating your program into
proprietary programs.  If your program is a subroutine library, you may
consider it more useful to permit linking proprietary applications with the
library.  If this is what you want to do, use the GNU Lesser General
Public License instead of this License.
*/

package jscover.instrument;

import com.google.javascript.jscomp.parsing.Config;
import jscover.ConfigurationCommon;
import jscover.util.ReflectionUtils;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;

import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.Matchers.equalTo;
import static org.hamcrest.Matchers.hasItem;
import static org.junit.Assert.assertEquals;
import static org.mockito.BDDMockito.given;

//Function Coverage added by Howard Abrams, CA Technologies (HA-CA) - May 20 2013, tntim96
@RunWith(MockitoJUnitRunner.class)
public class InstrumenterTest {

    @Mock private ConfigurationCommon config;
    private SourceProcessor sourceProcessor;
    private ParseTreeInstrumenter instrumenter;

    @Before
    public void setUp() {
        given(config.getECMAVersion()).willReturn(Config.LanguageMode.ECMASCRIPT8);
        given(config.isIncludeBranch()).willReturn(false);
        given(config.isIncludeFunction()).willReturn(true);
        sourceProcessor = new SourceProcessor(config, "test.js", "x;");
        instrumenter = (ParseTreeInstrumenter)ReflectionUtils.getField(sourceProcessor, "instrumenter");
    }


    @Test
    public void shouldInstrumentStatements() {
        String source = "var x,y;\nx = 1;\ny = x * 1;";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\nvar x, y;\n_$jscoverage['test.js'].lineData[2]++;\nx = 1;\n_$jscoverage['test.js'].lineData[3]++;\ny = x * 1;\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentDeclarationAcrossLines() {
        String source = "var x,\n" +
                "    y = new X(function () {\n" +
                "        return 1;\n" +
                "    });";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var x, y = new X(function() {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  return 1;\n" +
                "});\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldNotInstrumentReturnOfFunction() {
        String source = "return (\n" +
                "  function() {\n" +
                "});";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "return function() {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "};\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentIfStatementInSwitchCase() {
        String source = "switch (x) {\ncase 10:\nif (a) {\nx++;\n}\n}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "switch(x) {\n" +
                "  case 10:\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    if (a) {\n" +
                "      _$jscoverage['test.js'].lineData[4]++;\n" +
                "      x++;\n" +
                "    }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentStatementOnNewLineInSwitchCase() {//Bug 208
        String source = "  switch(x){ case 10: \nx++; }";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "switch(x) {\n" +
                "  case 10:\n" +
                "    _$jscoverage['test.js'].lineData[2]++;\n" +
                "    x++;\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentStatementFunctionAssignment() {
        String source = "this.someFn()\n    ._renderItem = function() {};";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\nthis.someFn()._renderItem = function() {\n  _$jscoverage['test.js'].functionData[0]++;\n};\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentIfWithLoopParent() {
        String source = "for ( var i = 0; i < 2; i++ )\n" +
                "if ( true )\n" +
                "  i++";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "for (var i = 0; i < 2; i++) {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  if (true) {\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    i++;\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentLoopWithLet() {
        String source = "for ( let i = 0; i < 2; i++ )\n" +
                "  i++";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "for (let i = 0; i < 2; i++) {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  i++;\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentLoopWithLetAcrossLines() {
        String source = "for (\nlet i = 0; i < 2; i++ )\n" +
                "  i++";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "for (let i = 0; i < 2; i++) {\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  i++;\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }


    @Test
    public void shouldInstrumentForOfLoopAcrossLines() {
        String source = "for (\nconst [x, y] of m)\n" +
                "  console.log(x,y);";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "for (const [x, y] of m) {\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  console.log(x, y);\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldNotInstrumentInsideForIn() {
        String source = "for (\n" +
                "var x in y) { }";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "for (" +
                "var x in y) {\n}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentIfWithIfParent() {
        String source = "if ( i > 0 )\n" +
                "  var x = 1;";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "if (i > 0) {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  var x = 1;\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentSwitchWithIfParent() {
        String source = "if ( i > 0 )\n" +
                "  switch(x) {\n" +
                "    case 1: break;\n" +
                "}\n";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "if (i > 0) {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  switch(x) {\n" +
                "    case 1:\n" +
                "      _$jscoverage['test.js'].lineData[3]++;\n" +
                "      break;\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentLoopWithIfParent() {
        String source = "if ( i > 0 )\n" +
                "  while ( i > 0 )\n" +
                "    i--;\n";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "if (i > 0) {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  while (i > 0) {\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    i--;\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentFunctionDeclarationAndAssignment() {
        String source = "var x,\n" +
                "  fn = function() {\n" +
                "    ;\n" +
                "  };";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var x, fn = function() {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "};\n";
        assertEquals(expectedSource, instrumentedSource);
        assertThat(instrumenter.getValidLines().size(), equalTo(2));
        assertThat(instrumenter.getValidLines(), hasItem(1));
        assertThat(instrumenter.getValidLines(), hasItem(3));
    }

    @Test
    public void shouldInstrumentFunctionDeclarationInInfix() {
        String source = "var x = {" +
                "  'y': 0,\n" +
                "  fn: 0 || function() {\n" +
                "    return 1;\n" +
                "  }" +
                "}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var x = {'y':0, fn:0 || function() {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  return 1;\n" +
                "}};\n";
        assertEquals(expectedSource, instrumentedSource);
        assertThat(instrumenter.getValidLines().size(), equalTo(2));
        assertThat(instrumenter.getValidLines(), hasItem(1));
        assertThat(instrumenter.getValidLines(), hasItem(3));
    }

    @Test
    public void shouldInstrumentFunctionInTernary() {
        String source = "var x = a > b ? \n" +
                "  function() {\n" +
                "    return true;" +
                "  } :\n" +
                "  function() {\n" +
                "    return false;\n" +
                "  }";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var x = a > b ? function() {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  return true;\n" +
                "} : function() {\n" +
                "  _$jscoverage['test.js'].functionData[1]++;\n" +
                "  _$jscoverage['test.js'].lineData[5]++;\n" +
                "  return false;\n" +
                "};\n";
        assertEquals(expectedSource, instrumentedSource);
        assertThat(instrumenter.getValidLines().size(), equalTo(3));
        assertThat(instrumenter.getValidLines(), hasItem(1));
        assertThat(instrumenter.getValidLines(), hasItem(3));
        assertThat(instrumenter.getValidLines(), hasItem(5));
    }

    @Test
    public void shouldInstrumentFunctionInArray() {
        String source = "var x = [\n" +
                "  function() {\n" +
                "    return true;\n" +
                "  }]\n";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var x = [function() {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  return true;\n" +
                "}];\n";
        assertEquals(expectedSource, instrumentedSource);
        assertThat(instrumenter.getValidLines().size(), equalTo(2));
        assertThat(instrumenter.getValidLines(), hasItem(1));
        assertThat(instrumenter.getValidLines(), hasItem(3));
    }

    @Test
    public void shouldInstrumentFunctionInBraces() {
        String source = "var x = \n" +
                "  (function() {\n" +
                "    return true;\n" +
                "  });\n";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var x = function() {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  return true;\n" +
                "};\n";
        assertEquals(expectedSource, instrumentedSource);
        assertThat(instrumenter.getValidLines().size(), equalTo(2));
        assertThat(instrumenter.getValidLines(), hasItem(1));
        assertThat(instrumenter.getValidLines(), hasItem(3));
    }

    @Test
    public void shouldInstrumentIfWithBraces() {
        String source = "if (x > 10)\n{\n  x++;\n}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\nif (x > 10) {\n  _$jscoverage['test.js'].lineData[3]++;\n  x++;\n}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentIfAcrossLines() {
        String source = "if (\nx > 10)\n{\n  x++;\n}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\nif (x > 10) {\n  _$jscoverage['test.js'].lineData[4]++;\n  x++;\n}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentIfWithoutBraces() {
        String source = "if (x > 10)\n  x++;";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\nif (x > 10) {\n  _$jscoverage['test.js'].lineData[2]++;\n  x++;\n}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentElseWithBraces() {
        String source = "if (x > 10)\n{\n  x++;\n} else {\n  x--;\n}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\nif (x > 10) {\n  _$jscoverage['test.js'].lineData[3]++;\n  x++;\n} else {\n  _$jscoverage['test.js'].lineData[5]++;\n  x--;\n}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldNotInstrumentSameLineTwice() {
        String source = "var x,y;\nx = 1;y = x * 1;";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\nvar x, y;\n_$jscoverage['test.js'].lineData[2]++;\nx = 1;\ny = x * 1;\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentLoopWithContinueLabel() {
        String source = "labelmark:\n" +
                "for( x=0; x<5; x++) {\n" +
                "  if (x)\n" +
                "    continue labelmark;\n" +
                "}\n";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "labelmark: for (x = 0; x < 5; x++) {\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  if (x) {\n" +
                "    _$jscoverage['test.js'].lineData[4]++;\n" +
                "    continue labelmark;\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentLoopWithBreakLabel() {
        String source = "label2: {\n" +
                "  f();\n" +
                "  while (x) {\n" +
                "    if (x) {\n" +
                "      break label2;\n" +
                "    }\n" +
                "  }\n" +
                "}\n";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "label2: {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  f();\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  while (x) {\n" +
                "    _$jscoverage['test.js'].lineData[4]++;\n" +
                "    if (x) {\n" +
                "      _$jscoverage['test.js'].lineData[5]++;\n" +
                "      break label2;\n" +
                "    }\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentLabelWithBraces() {
        String source = "outloop:\n" +
                "  {\n" +
                "    for (var j = 0; j < 10; j++) {\n" +
                "        break outloop;\n" +
                "    }\n" +
                "  }";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "outloop: {\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  for (var j = 0; j < 10; j++) {\n" +
                "    _$jscoverage['test.js'].lineData[4]++;\n" +
                "    break outloop;\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentLabelWithoutBraces() {
        String source = "outloop:\n" +
                "    for (var j = 0; j < 10; j++) {\n" +
                "        break outloop;\n" +
                "    }";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "outloop: for (var j = 0; j < 10; j++) {\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  break outloop;\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentIfElseNoBraceTry() {
        String source = "" +
                "if (condition)\n" +
                "  f1()\n" +
                "else try {\n" +
                "  f2()\n" +
                "} catch (ex) {\n" +
                "  f3(ex);\n" +
                "}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "if (condition) {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  f1();\n" +
                "} else {\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  try {\n" +
                "    _$jscoverage['test.js'].lineData[4]++;\n" +
                "    f2();\n" +
                "  } catch (ex) {\n" +
                "    _$jscoverage['test.js'].lineData[6]++;\n" +
                "    f3(ex);\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentIfElseTry() {
        String source = "" +
                "if (condition)\n" +
                "  f1()\n" +
                "else { try {\n" +
                "  f2()\n" +
                "} catch (ex) {\n" +
                "  f3(ex);\n" +
                "} }";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "if (condition) {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  f1();\n" +
                "} else {\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  try {\n" +
                "    _$jscoverage['test.js'].lineData[4]++;\n" +
                "    f2();\n" +
                "  } catch (ex) {\n" +
                "    _$jscoverage['test.js'].lineData[6]++;\n" +
                "    f3(ex);\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentWhileNoBraceTry() {
        String source = "" +
                "while (condition)\n" +
                "  try {\n" +
                "    f2()\n" +
                "  } catch (ex) {\n" +
                "    f3(ex);\n" +
                "  }";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "while (condition) {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  try {\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    f2();\n" +
                "  } catch (ex) {\n" +
                "    _$jscoverage['test.js'].lineData[5]++;\n" +
                "    f3(ex);\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentIfNoBraceWith() {
        String source = "if (c)\n with(o) {\n f();\n}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "if (c) {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  with(o) {\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    f();\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentIfNoBraceFunction() {
        String source = "if (c)\n function fn() { }";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "if (c) {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  function fn() {\n" +
                "    _$jscoverage['test.js'].functionData[0]++;\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentIfNoBraceWhile() {
        String source = "if (c)\n while(c2) {\n f()\n }";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "if (c) {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  while (c2) {\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    f();\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentWhileNoBraceReturn() {
        String source = "function f() {\nwhile (c)\n return f()\n}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "function f() {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  while (c) {\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    return f();\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentGetProp() {
        String source = "var x = y,\na = (function () {}).b; \n";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var x = y, a = function() {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "}.b;\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentArrayAcrossLines() {
        String source ="var x = [y,\n,];";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var x = [y, , ];\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentLoopAcrossLines() {
        String source ="for (\nx in y)\n;";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "for (x in y) {\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentForOf() {
        String source ="var m = [[1,2],[3,4]];\n" +
                "for (const [x, y] of m) {\n" +
                "  console.log(x);\n" +
                "  console.log(y);\n" +
                "}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var m = [[1, 2], [3, 4]];\n" +
                "_$jscoverage['test.js'].lineData[2]++;\n" +
                "for (const [x, y] of m) {\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  console.log(x);\n" +
                "  _$jscoverage['test.js'].lineData[4]++;\n" +
                "  console.log(y);\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentIgnoringLine() {
        String source = "var x = 7;" + CommentsHandler.EXCL_LINE;
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "var x = 7;\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentIgnoringLines() {
        String source = CommentsHandler.EXCL_START + "\nvar x = 7;" + CommentsHandler.EXCL_STOP;
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "var x = 7;\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6Export() {
        String source = "export var pi = 3.141593;";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "export var pi = 3.141593;\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6ExportStar() {
        String source = "export * from 'lib/math'";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "export*from 'lib/math';\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6ExportDefault() {
        String source = "export default x => Math.exp(x);";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "export default x => Math.exp(x)\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6Import() {
        String source = "import{sum, pi}from 'lib/math';";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "import{sum, pi}from 'lib/math';\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6ImportStar() {
        String source = "import * as math from 'lib/math';";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "import*as math from 'lib/math';\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6StringStartsWith() {
        String source = "var x = 'abc'.startsWith('a');";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var x = 'abc'.startsWith('a');\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6ArrowFunction() {
        String source = "var a3 = a.map(s => s.length );";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var a3 = a.map(s => s.length);\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test//https://developer.mozilla.org/en/docs/Web/JavaScript/Reference/Operators/Spread_operator
    public void shouldInstrumentES6SpreadOperator() {
        String source = "myFunction(...args);";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "myFunction(...args);\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6RestParameter() {
        String source = "myFunction(x, ...args);";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "myFunction(x, ...args);\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6ComputedObjectPropertyName() {
        String source = "let obj = {\n" +
                "    foo: \"bar\",\n" +
                "    [ \"baz\" + quux() ]: 42\n" +
                "}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "let obj = {foo:'bar', ['baz' + quux()]:42};\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6MemberFunction() {
        String source = "var x = {\n" +
                "    mounted () {\n" +
                "        this.onReady();\n" +
                "    }\n" +
                "};";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var x = {mounted() {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  this.onReady();\n" +
                "}};\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6ClassMemberFunction() {
        String source = "class Animal {\n" +
                "    speak () {\n" +
                "        return 1;\n" +
                "    }\n" +
                "}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "class Animal {\n" +
                "  speak() {\n" +
                "    _$jscoverage['test.js'].functionData[0]++;\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    return 1;\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6ClassConstructor() {
        String source = "class Rectangle {\n" +
                "  constructor(height, width) {\n" +
                "    this.height = height;\n" +
                "    this.width = width;\n" +
                "  }\n" +
                "}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "class Rectangle {\n" +
                "  constructor(height, width) {\n" +
                "    _$jscoverage['test.js'].functionData[0]++;\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    this.height = height;\n" +
                "    _$jscoverage['test.js'].lineData[4]++;\n" +
                "    this.width = width;\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldNotInstrumentES6ClassStatement() {
        String source = "class Rectangle {\n" +
                "  ;\n" +
                "}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "class Rectangle {\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6ClassPrototypeMethod() {
        String source = "class Rectangle {\n" +
                "  get area() {\n" +
                "    return 1;\n" +
                "  }\n" +
                "}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "class Rectangle {\n" +
                "  get area() {\n" +
                "    _$jscoverage['test.js'].functionData[0]++;\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    return 1;\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6ClassStaticMethod() {
        String source = "class Rectangle {\n" +
                "  static area(height, width) {\n" +
                "    return height * width;\n" +
                "  }\n" +
                "}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "class Rectangle {\n" +
                "  static area(height, width) {\n" +
                "    _$jscoverage['test.js'].functionData[0]++;\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    return height * width;\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6ClassSuper() {
        String source = "class Lion extends Cat {\n" +
                "  speak() {\n" +
                "    super.speak();\n" +
                "    console.log(this.name + ' roars.');\n" +
                "  }\n" +
                "}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "class Lion extends Cat {\n" +
                "  speak() {\n" +
                "    _$jscoverage['test.js'].functionData[0]++;\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    super.speak();\n" +
                "    _$jscoverage['test.js'].lineData[4]++;\n" +
                "    console.log(this.name + ' roars.');\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6ClassMixin() {
        String source = "var calculatorMixin = Base => class extends Base {\n" +
                "  calc() { }\n" +
                "};";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "var calculatorMixin = Base => class extends Base {\n" +
                "  calc() {\n" +
                "    _$jscoverage['test.js'].functionData[0]++;\n" +
                "  }\n" +
                "};\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6Const() {
        String source = "const PI = 3.141593;";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "const PI = 3.141593;\n";
        assertEquals(expectedSource, instrumentedSource);
    }


    @Test
    public void shouldInstrumentES6DefaultParamValues() {
        String source = "function f(x, y = 7, z = 42) {\n" +
                "    return x + y + z\n" +
                "}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "function f(x, y = 7, z = 42) {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  return x + y + z;\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6StatementBodies() {
        String source = "nums.forEach(v => {\n" +
                "    if (v % 5 === 0)\n" +
                "      fives.push(v)\n" +
                "})";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "nums.forEach(v => {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  if (v % 5 === 0) {\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    fives.push(v);\n" +
                "  }\n" +
                "});\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6BlockScopedFunction() {
        String source = "{\n" +
                "    function foo() {\n" +
                "        return 1\n" +
                "    }\n" +
                "\n" +
                "    foo() === 1\n" +
                "    {\n" +
                "        function foo() {\n" +
                "            return 2\n" +
                "        }\n" +
                "\n" +
                "        foo() === 2\n" +
                "    }\n" +
                "    foo() === 1\n" +
                "} ";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = " {\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  function foo() {\n" +
                "    _$jscoverage['test.js'].functionData[0]++;\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    return 1;\n" +
                "  }\n" +
                "  _$jscoverage['test.js'].lineData[6]++;\n" +
                "  foo() === 1;\n" +
                "  {\n" +
                "    _$jscoverage['test.js'].lineData[8]++;\n" +
                "    function foo() {\n" +
                "      _$jscoverage['test.js'].functionData[1]++;\n" +
                "      _$jscoverage['test.js'].lineData[9]++;\n" +
                "      return 2;\n" +
                "    }\n" +
                "    _$jscoverage['test.js'].lineData[12]++;\n" +
                "    foo() === 2;\n" +
                "  }\n" +
                "  _$jscoverage['test.js'].lineData[14]++;\n" +
                "  foo() === 1;\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6Iterator() {
        String source = "let fibonacci = {\n" +
                "    [Symbol.iterator]() {\n" +
                "        let pre = 0, cur = 1;\n" +
                "        return {\n" +
                "            next() {\n" +
                "                [pre, cur] = [cur, pre + cur];\n" +
                "                return {done: false, value: cur}\n" +
                "            }\n" +
                "        }\n" +
                "    }\n" +
                "};";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "let fibonacci = {[Symbol.iterator]() {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  let pre = 0, cur = 1;\n" +
                "  _$jscoverage['test.js'].lineData[4]++;\n" +
                "  return {next() {\n" +
                "    _$jscoverage['test.js'].functionData[1]++;\n" +
                "    _$jscoverage['test.js'].lineData[6]++;\n" +
                "    [pre, cur] = [cur, pre + cur];\n" +
                "    _$jscoverage['test.js'].lineData[7]++;\n" +
                "    return {done:false, value:cur};\n" +
                "  }};\n" +
                "}};\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6GeneratorFunctionIterator() {
        String source = "let fibonacci = {\n" +
                "    * [Symbol.iterator]() {\n" +
                "        let pre = 0, cur = 1;\n" +
                "        for (; ;) {\n" +
                "            [pre, cur] = [cur, pre + cur];\n" +
                "            yield cur\n" +
                "        }\n" +
                "    }\n" +
                "};";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "let fibonacci = {*[Symbol.iterator]() {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "  _$jscoverage['test.js'].lineData[3]++;\n" +
                "  let pre = 0, cur = 1;\n" +
                "  _$jscoverage['test.js'].lineData[4]++;\n" +
                "  for (;;) {\n" +
                "    _$jscoverage['test.js'].lineData[5]++;\n" +
                "    [pre, cur] = [cur, pre + cur];\n" +
                "    _$jscoverage['test.js'].lineData[6]++;\n" +
                "    yield cur;\n" +
                "  }\n" +
                "}};\n";
        assertEquals(expectedSource, instrumentedSource);
    }

    @Test
    public void shouldInstrumentES6GeneratorDirect() {
        String source = "function* range(start, end, step) {\n" +
                "    while (start < end) {\n" +
                "        yield start;\n" +
                "        start += step;\n" +
                "    }\n" +
                "}";
        String instrumentedSource = sourceProcessor.instrumentSource(source);
        String expectedSource = "_$jscoverage['test.js'].lineData[1]++;\n" +
                "function* range(start, end, step) {\n" +
                "  _$jscoverage['test.js'].functionData[0]++;\n" +
                "  _$jscoverage['test.js'].lineData[2]++;\n" +
                "  while (start < end) {\n" +
                "    _$jscoverage['test.js'].lineData[3]++;\n" +
                "    yield start;\n" +
                "    _$jscoverage['test.js'].lineData[4]++;\n" +
                "    start += step;\n" +
                "  }\n" +
                "}\n";
        assertEquals(expectedSource, instrumentedSource);
    }
}
